# check input params and if the corresponding files/dirs do exist
if ( $#ARGV != 1 ) {
  die "Usage: perl adjust.pl <identities.xml-file> <identities-path>";
}
open(IDENT, $ARGV[0]) or die "The identities file \"$ARGV[0]\" is missing";
$path = $ARGV[1];
open(PATH, $path) or warn "The directory $path does not exist";

# read original identities.xml file
while ($line = <IDENT>) {
 chomp($line);
 # if the line is a keystorepath, then convert the contained filename
 if ( $line =~ /^<keystorepath>.*[\\\/](.*)<\/keystorepath>/ ) { 
   # append $1 (the pure filename without path) to the $path
   $file = $path . $1;
   # check if $file exists
   open (FILE, $file) or warn "Keystore $file does not exist";
   # write the new keystorepath tag
   print "<keystorepath>$file</keystorepath>\n";
 } else {
   # just write the line
   print "$line\n";
 }
}

