#!/bin/sh
# Proxy Settings Helper Script for Mac OS X
# Copyright 2015 Health Info Net AG

function get_scutil {
  scutil='/usr/sbin/scutil'
  if [[ -x "$scutil" ]]; then
    return
  fi

  scutil='/sbin/scutil'
  if [[ -x "$scutil" ]]; then
    return
  fi

  scutil='/usr/bin/scutil'
  if [[ -x "$scutil" ]]; then
    return
  fi

  scutil='/bin/scutil'
  if [[ -x "$scutil" ]]; then
    return
  fi

  scutil=''
}

function get_networksetup {
  networksetup='/usr/sbin/networksetup'
  if [[ -x "$networksetup" ]]; then
    return
  fi

  networksetup='/sbin/networksetup'
  if [[ -x "$networksetup" ]]; then
    return
  fi

  networksetup='/usr/bin/networksetup'
  if [[ -x "$networksetup" ]]; then
    return
  fi

  networksetup='/bin/networksetup'
  if [[ -x "$networksetup" ]]; then
    return
  fi

  networksetup='/System/Library/CoreServices/RemoteManagement/ARDAgent.app/Contents/Support/networksetup-tiger'
  if [[ -x "$networksetup" ]]; then
    return
  fi

  networksetup='/System/Library/CoreServices/RemoteManagement/ARDAgent.app/Contents/Support/networksetup-panther'
  if [[ -x "$networksetup" ]]; then
    return
  fi

  networksetup=''
}

function call_scutil {
  get_scutil
  if [[ -n "$scutil" ]]; then
    "$scutil" "$@" || exit
  else
    echo 'Error: The command "scutil" is not available'>&2
    exit 2
  fi
}

function call_networksetup {
  get_networksetup
  if [[ -n "$networksetup" ]]; then
    "$networksetup" "$@" || exit
  else
    echo 'Error: The command "networksetup" is not available'>&2
    exit 3
  fi
}

if [[ "$1" = "get_network_state" ]]; then
  call_scutil<<EOF
show State:/Network/Global/IPv4
show State:/Network/Global/IPv6
quit
EOF
elif [[ "$1" = "get_proxy_settings" ]]; then
  call_scutil --proxy
elif [[ "$1" = "get_network_services" ]]; then
  call_networksetup -listnetworkserviceorder
elif [[ "$1" = "set_http_proxy" ]]; then
  call_networksetup -setwebproxy "$2" "$3" "$4" off
  if [[ "$5" = "off" ]]; then
    call_networksetup -setwebproxystate "$2" off
  fi
elif [[ "$1" = "enable_auto_proxy" ]]; then
  call_networksetup -setautoproxystate "$2" on
elif [[ "$1" = "disable_auto_proxy" ]]; then
  call_networksetup -setautoproxystate "$2" off
else
  echo 'Syntax error'>&2
  exit 1
fi
